const Light = require("../lib/core");
import {parse2query} from "../lib/utils"

function setCSS(){
    __base__.postPatch(`addCssNative("${__base__.bundlePath+"/app.miniapp.css"}")`,__base__.currentRoute);

    let env = __ENV__;
    if(env.plugins && env.plugins.toString().indexOf("jsnative")>-1){
        __base__.postPatch(`addCssNative("./css/jsnative/reset.css")`,__base__.currentRoute);
        __base__.postPatch(`addCssNative("./css/jsnative/base.css")`,__base__.currentRoute);
    }
}

module.exports = {
    start(router,options){
        //144925 lighting框架支持miniapp运行时-start接口
        const app = new Light.Vue({
            router,
            template:'<div><router-view/></div>',
            mounted:function(){
            }
        });
        router.push("/");
        app.$mount()
    },
    init(){
        __thread__.triggerEvent = function (type, args) {
            Light.trigger(type,args)
            if(type==="navigateBack"){
                Light.router.go(-1);
                __base__.currentRoute = Light.router.history.stack.length>1?Light.router.currentRoute.path:null;
            }
        };
        __base__.bundlePath = /^(.*)\/[^\/]*$/ig.exec(__base__.bundleUrl)[1];
        setCSS();
    },
    navigateBack(number){
        __base__.triggerEvent( "goBack" , {delta:number});
    },
    navigateTo(path,params,options){
        let router =  Light.router;
        if(!options.replace === true){
            __base__.triggerEvent( "goPage" , {
                path:"/"+path.view
            });
            // 这一句要放在triggerEvent之后，否则会导致iOS下多发一条removeChild的patch请求
            __base__.currentRoute = "/"+path.view;
            setCSS();

            router = Light.getRouter();
            const app = new Light.Vue({
                router,
                template:'<div><router-view/></div>',
                mounted:function(){
                }
            });
            app.$mount()
        }
        router.push({
            path:"/"+path.view,
            query:params
        });
    },
    getCurrentFile(){
        return '';
    },
    ajax(options){
        let body = options.data;

        if(!options.headers || !options.headers['Content-Type'] ||  options.headers['Content-Type'] === 'application/x-www-form-urlencoded'){
            body = parse2query(options.data);
        }

        LightJSBridge.call("stream.fetch",{
            url:options.url,
            method:options.type,
            headers:options.headers||{},
            type:options.dataType||"json",
            body:body
        },function (data) {
            if(+data.info.error_code !== 0){
                options.error(data.data.data);
            }else{
                options.success(data.data.data)
            }
        })
    }
};
